import { 
  select, 
  geoPath, 
  scaleOrdinal,
	schemeSpectral
} from 'd3';


import { loadAndProcessData } from './loadAndProcessData'
import { colorLegend } from './colorLegend'
import { choroplethMap } from './choroplethMap'

const svg = select('svg')

const choroplethMapG = svg.append('g')
const colorLegendG = svg.append('g')
	.attr('transform', `translate(30, 350)`)


const colorScale = scaleOrdinal()
const colorValue = d => d.properties.economy

let selectColorValue
let features

const onClick = d => {
	selectColorValue = d
  render()
}


loadAndProcessData().then(countries => {  
  features = countries.features
  render()
})


const render = () => {
	colorScale
    .domain(features.map(colorValue))
  	.domain(colorScale.domain().sort().reverse())
  	.range(schemeSpectral[colorScale.domain().length])
  
  colorLegendG.call(colorLegend, {
		colorScale,
  	circleRadius: 10,
  	spacing: 32,
  	textOffset: 30,
    backgroundRectWidth: 320,
    onClick,
    selectColorValue
	})

  	choroplethMapG.call(choroplethMap, {
    	features,
      colorValue,
      colorScale,
      selectColorValue
    })
 
}





